blob: c1d4970124da01b3f1ed85bd60422fafc303fc55 [file] [log] [blame]
Scott Anderson1a5fc952012-03-07 17:15:06 -08001function hmm() {
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07002cat <<EOF
Jeff Gastonc6dfc4e2017-05-30 17:12:37 -07003
4Run "m help" for help with the build system itself.
5
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08006Invoke ". build/envsetup.sh" from your shell to add the following functions to your environment:
Steven Moreland62054a42018-12-06 10:11:40 -08007- lunch: lunch <product_name>-<build_variant>
8 Selects <product_name> as the product to build, and <build_variant> as the variant to
9 build, and stores those selections in the environment to be read by subsequent
10 invocations of 'm' etc.
Elliott Hughesf71c05a2020-03-06 16:46:59 -080011- tapas: tapas [<App1> <App2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
Martin Stjernholmf692c752021-04-12 00:01:10 +010012 Sets up the build environment for building unbundled apps (APKs).
13- banchan: banchan <module1> [<module2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
14 Sets up the build environment for building unbundled modules (APEXes).
Anton Hanssonece9c482019-02-04 18:15:39 +000015- croot: Changes directory to the top of the tree, or a subdirectory thereof.
Steven Moreland62054a42018-12-06 10:11:40 -080016- m: Makes from the top of the tree.
Dan Willemsen67074fe2019-10-30 12:35:34 -070017- mm: Builds and installs all of the modules in the current directory, and their
18 dependencies.
19- mmm: Builds and installs all of the modules in the supplied directories, and their
20 dependencies.
Steven Moreland62054a42018-12-06 10:11:40 -080021 To limit the modules being built use the syntax: mmm dir/:target1,target2.
Dan Willemsen67074fe2019-10-30 12:35:34 -070022- mma: Same as 'mm'
23- mmma: Same as 'mmm'
Steven Moreland62054a42018-12-06 10:11:40 -080024- provision: Flash device with all required partitions. Options will be passed on to fastboot.
25- cgrep: Greps on all local C/C++ files.
26- ggrep: Greps on all local Gradle files.
Orion Hodson831472d2019-10-25 11:35:15 +010027- gogrep: Greps on all local Go files.
Steven Moreland62054a42018-12-06 10:11:40 -080028- jgrep: Greps on all local Java files.
Taesu Leeea0cecd2020-10-28 11:05:18 +090029- ktgrep: Greps on all local Kotlin files.
Steven Moreland62054a42018-12-06 10:11:40 -080030- resgrep: Greps on all local res/*.xml files.
31- mangrep: Greps on all local AndroidManifest.xml files.
Jaewoong Jung892d0fe2019-05-04 10:06:28 -070032- mgrep: Greps on all local Makefiles and *.bp files.
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -060033- owngrep: Greps on all local OWNERS files.
Alistair Delva176e5342021-02-22 13:31:26 -080034- rsgrep: Greps on all local Rust files.
Steven Moreland62054a42018-12-06 10:11:40 -080035- sepgrep: Greps on all local sepolicy files.
36- sgrep: Greps on all local source files.
37- godir: Go to the directory containing a file.
38- allmod: List all modules.
39- gomod: Go to the directory containing a module.
Rett Berg78d1c932019-01-24 14:34:23 -080040- pathmod: Get the directory containing a module.
Cole Faust24c36db2021-01-23 02:39:37 +000041- outmod: Gets the location of a module's installed outputs with a certain extension.
Joe Onorato2c1aa472021-02-25 16:42:39 -080042- dirmods: Gets the modules defined in a given directory.
Cole Faust24c36db2021-01-23 02:39:37 +000043- installmod: Adb installs a module's built APK.
44- refreshmod: Refresh list of modules for allmod/gomod/pathmod/outmod/installmod.
Steven Moreland74114f12020-09-10 01:23:32 +000045- syswrite: Remount partitions (e.g. system.img) as writable, rebooting if necessary.
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070046
Roland Levillain39341922015-10-20 12:48:19 +010047Environment options:
Steven Moreland115d1f52019-09-26 16:30:28 -070048- SANITIZE_HOST: Set to 'address' to use ASAN for all host modules.
Sasha Smundak9f27cc02019-01-31 13:25:31 -080049- ANDROID_QUIET_BUILD: set to 'true' to display only the essential messages.
Dan Albert4ae5d4b2014-10-31 16:23:08 -070050
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070051Look at the source to view more functions. The complete list is:
52EOF
Christopher Ferris55257d22017-03-23 11:08:58 -070053 local T=$(gettop)
54 local A=""
55 local i
Jacky Cao89483b82015-05-15 22:12:53 +080056 for i in `cat $T/build/envsetup.sh | sed -n "/^[[:blank:]]*function /s/function \([a-z_]*\).*/\1/p" | sort | uniq`; do
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070057 A="$A $i"
58 done
59 echo $A
60}
61
Ying Wang08800fd2016-03-03 20:57:21 -080062# Get all the build variables needed by this script in a single call to the build system.
Matt Alexanderd9c56562020-05-21 10:49:17 +000063function build_build_var_cache()
64{
Christopher Ferris55257d22017-03-23 11:08:58 -070065 local T=$(gettop)
Ying Wang08800fd2016-03-03 20:57:21 -080066 # Grep out the variable names from the script.
Jim Tanga881a252018-06-19 16:34:41 +080067 cached_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
68 cached_abs_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_abs_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
Ying Wang08800fd2016-03-03 20:57:21 -080069 # Call the build system to dump the "<val>=<value>" pairs as a shell script.
Steven Moreland05402962018-01-05 12:13:11 -080070 build_dicts_script=`\builtin cd $T; build/soong/soong_ui.bash --dumpvars-mode \
Jim Tanga881a252018-06-19 16:34:41 +080071 --vars="${cached_vars[*]}" \
72 --abs-vars="${cached_abs_vars[*]}" \
Dan Willemsenaf88c412017-07-14 11:29:44 -070073 --var-prefix=var_cache_ \
74 --abs-var-prefix=abs_var_cache_`
Ying Wang08800fd2016-03-03 20:57:21 -080075 local ret=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +000076 if [ $ret -ne 0 ]
77 then
Ying Wang08800fd2016-03-03 20:57:21 -080078 unset build_dicts_script
79 return $ret
80 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -070081 # Execute the script to store the "<val>=<value>" pairs as shell variables.
Ying Wang08800fd2016-03-03 20:57:21 -080082 eval "$build_dicts_script"
Ying Wang08800fd2016-03-03 20:57:21 -080083 ret=$?
Ying Wangf0cb3972016-03-04 13:56:23 -080084 unset build_dicts_script
Matt Alexanderd9c56562020-05-21 10:49:17 +000085 if [ $ret -ne 0 ]
86 then
Ying Wang08800fd2016-03-03 20:57:21 -080087 return $ret
88 fi
89 BUILD_VAR_CACHE_READY="true"
90}
91
Ying Wangf0cb3972016-03-04 13:56:23 -080092# Delete the build var cache, so that we can still call into the build system
Ying Wang08800fd2016-03-03 20:57:21 -080093# to get build variables not listed in this script.
Matt Alexanderd9c56562020-05-21 10:49:17 +000094function destroy_build_var_cache()
95{
Ying Wang08800fd2016-03-03 20:57:21 -080096 unset BUILD_VAR_CACHE_READY
Christopher Ferris55257d22017-03-23 11:08:58 -070097 local v
Ying Wang08800fd2016-03-03 20:57:21 -080098 for v in $cached_vars; do
99 unset var_cache_$v
100 done
101 unset cached_vars
102 for v in $cached_abs_vars; do
103 unset abs_var_cache_$v
104 done
105 unset cached_abs_vars
106}
107
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700108# Get the value of a build variable as an absolute path.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000109function get_abs_build_var()
110{
111 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
112 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800113 eval "echo \"\${abs_var_cache_$1}\""
Timi0469c3f2021-04-15 16:41:18 +0200114 return
Ying Wang08800fd2016-03-03 20:57:21 -0800115 fi
116
Christopher Ferris55257d22017-03-23 11:08:58 -0700117 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700118 if [ ! "$T" ]; then
119 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
120 return
121 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700122 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode --abs $1)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700123}
124
125# Get the exact value of a build variable.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000126function get_build_var()
127{
128 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
129 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800130 eval "echo \"\${var_cache_$1}\""
Roland Levillain23c46cf2020-03-31 16:11:05 +0100131 return 0
Ying Wang08800fd2016-03-03 20:57:21 -0800132 fi
133
Christopher Ferris55257d22017-03-23 11:08:58 -0700134 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700135 if [ ! "$T" ]; then
136 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
Roland Levillain23c46cf2020-03-31 16:11:05 +0100137 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700138 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700139 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode $1)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800140}
141
142# check to see if the supplied product is one we can build
Matt Alexanderd9c56562020-05-21 10:49:17 +0000143function check_product()
144{
Christopher Ferris55257d22017-03-23 11:08:58 -0700145 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800146 if [ ! "$T" ]; then
147 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
148 return
149 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700150 TARGET_PRODUCT=$1 \
151 TARGET_BUILD_VARIANT= \
152 TARGET_BUILD_TYPE= \
Joe Onoratoda12daf2010-06-09 18:18:31 -0700153 TARGET_BUILD_APPS= \
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800154 get_build_var TARGET_DEVICE > /dev/null
155 # hide successful answers, but allow the errors to show
156}
157
158VARIANT_CHOICES=(user userdebug eng)
159
160# check to see if the supplied variant is valid
Matt Alexanderd9c56562020-05-21 10:49:17 +0000161function check_variant()
162{
Christopher Ferris55257d22017-03-23 11:08:58 -0700163 local v
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800164 for v in ${VARIANT_CHOICES[@]}
165 do
Matt Alexanderd9c56562020-05-21 10:49:17 +0000166 if [ "$v" = "$1" ]
167 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800168 return 0
169 fi
170 done
171 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700172}
173
Matt Alexanderd9c56562020-05-21 10:49:17 +0000174function setpaths()
175{
Christopher Ferris55257d22017-03-23 11:08:58 -0700176 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700177 if [ ! "$T" ]; then
178 echo "Couldn't locate the top of the tree. Try setting TOP."
179 return
180 fi
181
182 ##################################################################
183 # #
184 # Read me before you modify this code #
185 # #
186 # This function sets ANDROID_BUILD_PATHS to what it is adding #
187 # to PATH, and the next time it is run, it removes that from #
188 # PATH. This is required so lunch can be run more than once #
189 # and still have working paths. #
190 # #
191 ##################################################################
192
Raphael Mollc639c782011-06-20 17:25:01 -0700193 # Note: on windows/cygwin, ANDROID_BUILD_PATHS will contain spaces
194 # due to "C:\Program Files" being in the path.
195
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700196 # out with the old
Matt Alexanderd9c56562020-05-21 10:49:17 +0000197 if [ -n "$ANDROID_BUILD_PATHS" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700198 export PATH=${PATH/$ANDROID_BUILD_PATHS/}
199 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000200 if [ -n "$ANDROID_PRE_BUILD_PATHS" ] ; then
Doug Zongker29034982011-04-22 08:16:56 -0700201 export PATH=${PATH/$ANDROID_PRE_BUILD_PATHS/}
Ying Wangaa1c9b52012-11-26 20:51:59 -0800202 # strip leading ':', if any
203 export PATH=${PATH/:%/}
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500204 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700205
206 # and in with the new
Christopher Ferris55257d22017-03-23 11:08:58 -0700207 local prebuiltdir=$(getprebuilt)
208 local gccprebuiltdir=$(get_abs_build_var ANDROID_GCC_PREBUILTS)
Raphael732936d2011-06-22 14:35:32 -0700209
Ben Cheng8bc4c432012-11-16 13:29:13 -0800210 # defined in core/config.mk
Christopher Ferris55257d22017-03-23 11:08:58 -0700211 local targetgccversion=$(get_build_var TARGET_GCC_VERSION)
212 local targetgccversion2=$(get_build_var 2ND_TARGET_GCC_VERSION)
Ben Cheng15266702012-12-10 16:04:39 -0800213 export TARGET_GCC_VERSION=$targetgccversion
Ben Cheng8bc4c432012-11-16 13:29:13 -0800214
Raphael Mollc639c782011-06-20 17:25:01 -0700215 # The gcc toolchain does not exists for windows/cygwin. In this case, do not reference it.
Ben Chengfba67bf2014-02-25 10:27:07 -0800216 export ANDROID_TOOLCHAIN=
217 export ANDROID_TOOLCHAIN_2ND_ARCH=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200218 local ARCH=$(get_build_var TARGET_ARCH)
Christopher Ferris55257d22017-03-23 11:08:58 -0700219 local toolchaindir toolchaindir2=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200220 case $ARCH in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000221 x86) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Mark D Horn7d0ede72012-03-14 14:20:30 -0700222 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000223 x86_64) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Pavel Chupinfd82a492012-11-26 09:50:07 +0400224 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000225 arm) toolchaindir=arm/arm-linux-androideabi-$targetgccversion/bin
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200226 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000227 arm64) toolchaindir=aarch64/aarch64-linux-android-$targetgccversion/bin;
228 toolchaindir2=arm/arm-linux-androideabi-$targetgccversion2/bin
Ben Chengdb4fc202013-10-04 16:02:59 -0700229 ;;
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200230 *)
231 echo "Can't find toolchain for unknown architecture: $ARCH"
232 toolchaindir=xxxxxxxxx
Mark D Horn7d0ede72012-03-14 14:20:30 -0700233 ;;
234 esac
Jing Yuf5172c72012-03-29 20:45:50 -0700235 if [ -d "$gccprebuiltdir/$toolchaindir" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800236 export ANDROID_TOOLCHAIN=$gccprebuiltdir/$toolchaindir
Raphael Mollc639c782011-06-20 17:25:01 -0700237 fi
Raphael732936d2011-06-22 14:35:32 -0700238
Christopher Ferris55257d22017-03-23 11:08:58 -0700239 if [ "$toolchaindir2" -a -d "$gccprebuiltdir/$toolchaindir2" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800240 export ANDROID_TOOLCHAIN_2ND_ARCH=$gccprebuiltdir/$toolchaindir2
241 fi
242
Dan Willemsen838dcec2021-09-30 22:40:34 +0000243 export ANDROID_DEV_SCRIPTS=$T/development/scripts:$T/prebuilts/devtools/tools
Yueyao Zhuefc786a2017-04-07 14:11:54 -0700244
245 # add kernel specific binaries
246 case $(uname -s) in
247 Linux)
248 export ANDROID_DEV_SCRIPTS=$ANDROID_DEV_SCRIPTS:$T/prebuilts/misc/linux-x86/dtc:$T/prebuilts/misc/linux-x86/libufdt
249 ;;
250 *)
251 ;;
252 esac
253
Torne (Richard Coles)0091bae2017-10-03 16:31:18 -0400254 ANDROID_BUILD_PATHS=$(get_build_var ANDROID_BUILD_PATHS):$ANDROID_TOOLCHAIN
Martin Stjernholm6a012262021-11-24 14:56:15 +0000255 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_TOOLCHAIN_2ND_ARCH
Yi Kongdfd00b12019-05-21 16:00:04 -0700256 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_DEV_SCRIPTS
257
258 # Append llvm binutils prebuilts path to ANDROID_BUILD_PATHS.
259 local ANDROID_LLVM_BINUTILS=$(get_abs_build_var ANDROID_CLANG_PREBUILTS)/llvm-binutils-stable
260 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_LLVM_BINUTILS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200261
Stephen Hinesaa8d72c2020-02-04 09:15:18 -0800262 # Set up ASAN_SYMBOLIZER_PATH for SANITIZE_HOST=address builds.
263 export ASAN_SYMBOLIZER_PATH=$ANDROID_LLVM_BINUTILS/llvm-symbolizer
264
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200265 # If prebuilts/android-emulator/<system>/ exists, prepend it to our PATH
266 # to ensure that the corresponding 'emulator' binaries are used.
267 case $(uname -s) in
268 Darwin)
269 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/darwin-x86_64
270 ;;
271 Linux)
272 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/linux-x86_64
273 ;;
274 *)
275 ANDROID_EMULATOR_PREBUILTS=
276 ;;
277 esac
278 if [ -n "$ANDROID_EMULATOR_PREBUILTS" -a -d "$ANDROID_EMULATOR_PREBUILTS" ]; then
Yi Kongdfd00b12019-05-21 16:00:04 -0700279 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_EMULATOR_PREBUILTS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200280 export ANDROID_EMULATOR_PREBUILTS
281 fi
282
Jim Tangb3fda302018-12-22 10:24:55 +0800283 # Append asuite prebuilts path to ANDROID_BUILD_PATHS.
284 local os_arch=$(get_build_var HOST_PREBUILT_TAG)
Ryan Prichard8426a192019-07-15 18:05:29 -0700285 local ACLOUD_PATH="$T/prebuilts/asuite/acloud/$os_arch"
286 local AIDEGEN_PATH="$T/prebuilts/asuite/aidegen/$os_arch"
287 local ATEST_PATH="$T/prebuilts/asuite/atest/$os_arch"
Martin Stjernholm6a012262021-11-24 14:56:15 +0000288 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ACLOUD_PATH:$AIDEGEN_PATH:$ATEST_PATH
Jim Tangb3fda302018-12-22 10:24:55 +0800289
Martin Stjernholm6a012262021-11-24 14:56:15 +0000290 export ANDROID_BUILD_PATHS=$(tr -s : <<<"${ANDROID_BUILD_PATHS}:")
Ryan Prichard8426a192019-07-15 18:05:29 -0700291 export PATH=$ANDROID_BUILD_PATHS$PATH
Jim Tang22f4c322018-12-17 15:21:53 +0800292
293 # out with the duplicate old
294 if [ -n $ANDROID_PYTHONPATH ]; then
295 export PYTHONPATH=${PYTHONPATH//$ANDROID_PYTHONPATH/}
296 fi
297 # and in with the new
298 export ANDROID_PYTHONPATH=$T/development/python-packages:
Jim Tangc4dba1d2019-07-25 16:54:27 +0800299 if [ -n $VENDOR_PYTHONPATH ]; then
300 ANDROID_PYTHONPATH=$ANDROID_PYTHONPATH$VENDOR_PYTHONPATH
301 fi
Jim Tang22f4c322018-12-17 15:21:53 +0800302 export PYTHONPATH=$ANDROID_PYTHONPATH$PYTHONPATH
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800303
Colin Crosse97e6932017-06-30 16:01:45 -0700304 export ANDROID_JAVA_HOME=$(get_abs_build_var ANDROID_JAVA_HOME)
305 export JAVA_HOME=$ANDROID_JAVA_HOME
306 export ANDROID_JAVA_TOOLCHAIN=$(get_abs_build_var ANDROID_JAVA_TOOLCHAIN)
307 export ANDROID_PRE_BUILD_PATHS=$ANDROID_JAVA_TOOLCHAIN:
308 export PATH=$ANDROID_PRE_BUILD_PATHS$PATH
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500309
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800310 unset ANDROID_PRODUCT_OUT
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700311 export ANDROID_PRODUCT_OUT=$(get_abs_build_var PRODUCT_OUT)
312 export OUT=$ANDROID_PRODUCT_OUT
313
Jeff Brown8fd5cce2011-03-24 17:03:06 -0700314 unset ANDROID_HOST_OUT
315 export ANDROID_HOST_OUT=$(get_abs_build_var HOST_OUT)
316
Jiyong Parkc02b1c42020-11-03 11:06:39 +0900317 unset ANDROID_SOONG_HOST_OUT
318 export ANDROID_SOONG_HOST_OUT=$(get_abs_build_var SOONG_HOST_OUT)
319
Simran Basidd050ed2017-02-13 13:46:48 -0800320 unset ANDROID_HOST_OUT_TESTCASES
321 export ANDROID_HOST_OUT_TESTCASES=$(get_abs_build_var HOST_OUT_TESTCASES)
322
323 unset ANDROID_TARGET_OUT_TESTCASES
324 export ANDROID_TARGET_OUT_TESTCASES=$(get_abs_build_var TARGET_OUT_TESTCASES)
325
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800326 # needed for building linux on MacOS
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700327 # TODO: fix the path
328 #export HOST_EXTRACFLAGS="-I "$T/system/kernel_headers/host_include
329}
330
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000331function bazel()
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000332{
Jingwen Chen17d56992021-06-10 08:17:54 +0000333 if which bazel &>/dev/null; then
334 >&2 echo "NOTE: bazel() function sourced from Android's envsetup.sh is being used instead of $(which bazel)"
335 >&2 echo
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000336 fi
337
Jingwen Chen17d56992021-06-10 08:17:54 +0000338 local T="$(gettop)"
339 if [ ! "$T" ]; then
340 >&2 echo "Couldn't locate the top of the Android tree. Try setting TOP. This bazel() function cannot be used outside of the AOSP directory."
341 return
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000342 fi
343
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000344 "$T/tools/bazel" "$@"
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000345}
346
Matt Alexanderd9c56562020-05-21 10:49:17 +0000347function printconfig()
348{
Christopher Ferris55257d22017-03-23 11:08:58 -0700349 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800350 if [ ! "$T" ]; then
351 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
352 return
353 fi
354 get_build_var report_config
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700355}
356
Matt Alexanderd9c56562020-05-21 10:49:17 +0000357function set_stuff_for_environment()
358{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800359 setpaths
360 set_sequence_number
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700361
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800362 export ANDROID_BUILD_TOP=$(gettop)
Ben Chengaac3f812013-08-13 14:38:15 -0700363 # With this environment variable new GCC can apply colors to warnings/errors
364 export GCC_COLORS='error=01;31:warning=01;35:note=01;36:caret=01;32:locus=01:quote=01'
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700365}
366
Matt Alexanderd9c56562020-05-21 10:49:17 +0000367function set_sequence_number()
368{
Colin Cross88737132017-03-21 17:41:03 -0700369 export BUILD_ENV_SEQUENCE_NUMBER=13
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700370}
371
Makoto Onukida971062018-06-18 10:15:19 -0700372# Takes a command name, and check if it's in ENVSETUP_NO_COMPLETION or not.
373function should_add_completion() {
Jim Tanga881a252018-06-19 16:34:41 +0800374 local cmd="$(basename $1| sed 's/_completion//' |sed 's/\.\(.*\)*sh$//')"
Makoto Onukida971062018-06-18 10:15:19 -0700375 case :"$ENVSETUP_NO_COMPLETION": in
Jim Tanga881a252018-06-19 16:34:41 +0800376 *:"$cmd":*)
377 return 1
378 ;;
Makoto Onukida971062018-06-18 10:15:19 -0700379 esac
380 return 0
381}
382
Matt Alexanderd9c56562020-05-21 10:49:17 +0000383function addcompletions()
384{
Ben Taitelbaum8c2c9cf2020-09-22 16:45:05 -0700385 local f=
Kenny Root52aa81c2011-07-15 11:07:06 -0700386
Jim Tanga881a252018-06-19 16:34:41 +0800387 # Keep us from trying to run in something that's neither bash nor zsh.
388 if [ -z "$BASH_VERSION" -a -z "$ZSH_VERSION" ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700389 return
390 fi
391
392 # Keep us from trying to run in bash that's too old.
Jim Tanga881a252018-06-19 16:34:41 +0800393 if [ -n "$BASH_VERSION" -a ${BASH_VERSINFO[0]} -lt 3 ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700394 return
395 fi
396
Jim Tanga881a252018-06-19 16:34:41 +0800397 local completion_files=(
398 system/core/adb/adb.bash
399 system/core/fastboot/fastboot.bash
Jim Tangb3fda302018-12-22 10:24:55 +0800400 tools/asuite/asuite.sh
Jim Tanga881a252018-06-19 16:34:41 +0800401 )
Makoto Onukida971062018-06-18 10:15:19 -0700402 # Completion can be disabled selectively to allow users to use non-standard completion.
403 # e.g.
404 # ENVSETUP_NO_COMPLETION=adb # -> disable adb completion
405 # ENVSETUP_NO_COMPLETION=adb:bit # -> disable adb and bit completion
Jim Tanga881a252018-06-19 16:34:41 +0800406 for f in ${completion_files[*]}; do
407 if [ -f "$f" ] && should_add_completion "$f"; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700408 . $f
Elliott Hughesce18dd42018-04-03 13:49:48 -0700409 fi
410 done
Joe Onorato002a6c72016-10-20 16:39:49 -0700411
Matt Alexanderd9c56562020-05-21 10:49:17 +0000412 if should_add_completion bit ; then
Makoto Onukida971062018-06-18 10:15:19 -0700413 complete -C "bit --tab" bit
414 fi
Anton Hanssonece9c482019-02-04 18:15:39 +0000415 if [ -z "$ZSH_VERSION" ]; then
416 # Doesn't work in zsh.
417 complete -o nospace -F _croot croot
418 fi
Jim Tanga881a252018-06-19 16:34:41 +0800419 complete -F _lunch lunch
Steven Moreland62054a42018-12-06 10:11:40 -0800420
Cole Faust24c36db2021-01-23 02:39:37 +0000421 complete -F _complete_android_module_names pathmod
dimitry73b84812018-12-11 18:06:00 +0100422 complete -F _complete_android_module_names gomod
Cole Faust24c36db2021-01-23 02:39:37 +0000423 complete -F _complete_android_module_names outmod
424 complete -F _complete_android_module_names installmod
dimitry73b84812018-12-11 18:06:00 +0100425 complete -F _complete_android_module_names m
Kenny Root52aa81c2011-07-15 11:07:06 -0700426}
427
Matt Alexanderd9c56562020-05-21 10:49:17 +0000428function choosetype()
429{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700430 echo "Build type choices are:"
431 echo " 1. release"
432 echo " 2. debug"
433 echo
434
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800435 local DEFAULT_NUM DEFAULT_VALUE
Jeff Browne33ba4c2011-07-11 22:11:46 -0700436 DEFAULT_NUM=1
437 DEFAULT_VALUE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700438
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800439 export TARGET_BUILD_TYPE=
440 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700441 while [ -z $TARGET_BUILD_TYPE ]
442 do
443 echo -n "Which would you like? ["$DEFAULT_NUM"] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000444 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800445 read ANSWER
446 else
447 echo $1
448 ANSWER=$1
449 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700450 case $ANSWER in
451 "")
452 export TARGET_BUILD_TYPE=$DEFAULT_VALUE
453 ;;
454 1)
455 export TARGET_BUILD_TYPE=release
456 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800457 release)
458 export TARGET_BUILD_TYPE=release
459 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700460 2)
461 export TARGET_BUILD_TYPE=debug
462 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800463 debug)
464 export TARGET_BUILD_TYPE=debug
465 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700466 *)
467 echo
468 echo "I didn't understand your response. Please try again."
469 echo
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700470 ;;
471 esac
Matt Alexanderd9c56562020-05-21 10:49:17 +0000472 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800473 break
474 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700475 done
476
Ying Wang08800fd2016-03-03 20:57:21 -0800477 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700478 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800479 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700480}
481
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800482#
483# This function isn't really right: It chooses a TARGET_PRODUCT
484# based on the list of boards. Usually, that gets you something
485# that kinda works with a generic product, but really, you should
486# pick a product by name.
487#
Matt Alexanderd9c56562020-05-21 10:49:17 +0000488function chooseproduct()
489{
Christopher Ferris55257d22017-03-23 11:08:58 -0700490 local default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000491 if [ "x$TARGET_PRODUCT" != x ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700492 default_value=$TARGET_PRODUCT
493 else
Ying Wang0a76df52015-06-08 11:57:26 -0700494 default_value=aosp_arm
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700495 fi
496
Ying Wang08800fd2016-03-03 20:57:21 -0800497 export TARGET_BUILD_APPS=
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800498 export TARGET_PRODUCT=
499 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700500 while [ -z "$TARGET_PRODUCT" ]
501 do
Joe Onorato8849aed2009-04-29 15:56:47 -0700502 echo -n "Which product would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000503 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800504 read ANSWER
505 else
506 echo $1
507 ANSWER=$1
508 fi
509
Matt Alexanderd9c56562020-05-21 10:49:17 +0000510 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700511 export TARGET_PRODUCT=$default_value
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800512 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000513 if check_product $ANSWER
514 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800515 export TARGET_PRODUCT=$ANSWER
516 else
517 echo "** Not a valid product: $ANSWER"
518 fi
519 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000520 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800521 break
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700522 fi
523 done
524
Ying Wang08800fd2016-03-03 20:57:21 -0800525 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700526 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800527 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700528}
529
Matt Alexanderd9c56562020-05-21 10:49:17 +0000530function choosevariant()
531{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800532 echo "Variant choices are:"
533 local index=1
534 local v
535 for v in ${VARIANT_CHOICES[@]}
536 do
537 # The product name is the name of the directory containing
538 # the makefile we found, above.
539 echo " $index. $v"
540 index=$(($index+1))
541 done
542
543 local default_value=eng
544 local ANSWER
545
546 export TARGET_BUILD_VARIANT=
547 while [ -z "$TARGET_BUILD_VARIANT" ]
548 do
549 echo -n "Which would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000550 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800551 read ANSWER
552 else
553 echo $1
554 ANSWER=$1
555 fi
556
Matt Alexanderd9c56562020-05-21 10:49:17 +0000557 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800558 export TARGET_BUILD_VARIANT=$default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000559 elif (echo -n $ANSWER | grep -q -e "^[0-9][0-9]*$") ; then
560 if [ "$ANSWER" -le "${#VARIANT_CHOICES[@]}" ] ; then
Guillaume Chelfice000fd2019-10-03 12:02:46 +0200561 export TARGET_BUILD_VARIANT=${VARIANT_CHOICES[@]:$(($ANSWER-1)):1}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800562 fi
563 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000564 if check_variant $ANSWER
565 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800566 export TARGET_BUILD_VARIANT=$ANSWER
567 else
568 echo "** Not a valid variant: $ANSWER"
569 fi
570 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000571 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800572 break
573 fi
574 done
575}
576
Matt Alexanderd9c56562020-05-21 10:49:17 +0000577function choosecombo()
578{
Jeff Browne33ba4c2011-07-11 22:11:46 -0700579 choosetype $1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700580
581 echo
582 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700583 chooseproduct $2
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700584
585 echo
586 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700587 choosevariant $3
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800588
589 echo
Ying Wang08800fd2016-03-03 20:57:21 -0800590 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700591 set_stuff_for_environment
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800592 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800593 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700594}
595
Matt Alexanderd9c56562020-05-21 10:49:17 +0000596function add_lunch_combo()
597{
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800598 if [ -n "$ZSH_VERSION" ]; then
599 echo -n "${funcfiletrace[1]}: "
600 else
601 echo -n "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: "
602 fi
603 echo "add_lunch_combo is obsolete. Use COMMON_LUNCH_CHOICES in your AndroidProducts.mk instead."
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800604}
605
Matt Alexanderd9c56562020-05-21 10:49:17 +0000606function print_lunch_menu()
607{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700608 local uname=$(uname)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100609 local choices
Colin Crossfa50d402021-04-22 13:05:41 -0700610 choices=$(TARGET_BUILD_APPS= TARGET_PRODUCT= TARGET_BUILD_VARIANT= get_build_var COMMON_LUNCH_CHOICES 2>/dev/null)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100611 local ret=$?
612
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700613 echo
614 echo "You're building on" $uname
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700615 echo
Roland Levillain23c46cf2020-03-31 16:11:05 +0100616
Matt Alexanderd9c56562020-05-21 10:49:17 +0000617 if [ $ret -ne 0 ]
618 then
Roland Levillain23c46cf2020-03-31 16:11:05 +0100619 echo "Warning: Cannot display lunch menu."
620 echo
621 echo "Note: You can invoke lunch with an explicit target:"
622 echo
623 echo " usage: lunch [target]" >&2
624 echo
625 return
626 fi
627
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700628 echo "Lunch menu... pick a combo:"
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800629
630 local i=1
631 local choice
Dan Willemsen91763e92019-10-03 15:13:12 -0700632 for choice in $(echo $choices)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800633 do
634 echo " $i. $choice"
635 i=$(($i+1))
636 done
637
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700638 echo
639}
640
Matt Alexanderd9c56562020-05-21 10:49:17 +0000641function lunch()
642{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800643 local answer
644
Steven Moreland92793dc2020-02-25 18:30:18 -0800645 if [[ $# -gt 1 ]]; then
646 echo "usage: lunch [target]" >&2
647 return 1
648 fi
649
650 if [ "$1" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800651 answer=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700652 else
653 print_lunch_menu
Jean-Baptiste Queru324c1232013-03-22 15:53:54 -0700654 echo -n "Which would you like? [aosp_arm-eng] "
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800655 read answer
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700656 fi
657
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800658 local selection=
659
Matt Alexanderd9c56562020-05-21 10:49:17 +0000660 if [ -z "$answer" ]
661 then
Jean-Baptiste Queru324c1232013-03-22 15:53:54 -0700662 selection=aosp_arm-eng
Matt Alexanderd9c56562020-05-21 10:49:17 +0000663 elif (echo -n $answer | grep -q -e "^[0-9][0-9]*$")
664 then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800665 local choices=($(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES))
Matt Alexanderd9c56562020-05-21 10:49:17 +0000666 if [ $answer -le ${#choices[@]} ]
667 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800668 # array in zsh starts from 1 instead of 0.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000669 if [ -n "$ZSH_VERSION" ]
670 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800671 selection=${choices[$(($answer))]}
672 else
673 selection=${choices[$(($answer-1))]}
674 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800675 fi
Colin Cross88737132017-03-21 17:41:03 -0700676 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800677 selection=$answer
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700678 fi
679
Joe Onoratoda12daf2010-06-09 18:18:31 -0700680 export TARGET_BUILD_APPS=
681
Colin Cross88737132017-03-21 17:41:03 -0700682 local product variant_and_version variant version
Colin Cross88737132017-03-21 17:41:03 -0700683 product=${selection%%-*} # Trim everything after first dash
684 variant_and_version=${selection#*-} # Trim everything up to first dash
685 if [ "$variant_and_version" != "$selection" ]; then
686 variant=${variant_and_version%%-*}
687 if [ "$variant" != "$variant_and_version" ]; then
688 version=${variant_and_version#*-}
689 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700690 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800691
Matt Alexanderd9c56562020-05-21 10:49:17 +0000692 if [ -z "$product" ]
693 then
Ying Wang08800fd2016-03-03 20:57:21 -0800694 echo
Colin Cross88737132017-03-21 17:41:03 -0700695 echo "Invalid lunch combo: $selection"
Jeff Browne33ba4c2011-07-11 22:11:46 -0700696 return 1
697 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800698
Colin Cross88737132017-03-21 17:41:03 -0700699 TARGET_PRODUCT=$product \
700 TARGET_BUILD_VARIANT=$variant \
701 TARGET_PLATFORM_VERSION=$version \
702 build_build_var_cache
Matt Alexanderd9c56562020-05-21 10:49:17 +0000703 if [ $? -ne 0 ]
704 then
Anton Hansson32fa7ee2021-06-14 17:09:58 +0100705 if [[ "$product" =~ .*_(eng|user|userdebug) ]]
706 then
707 echo "Did you mean -${product/*_/}? (dash instead of underscore)"
708 fi
Colin Cross88737132017-03-21 17:41:03 -0700709 return 1
710 fi
Colin Cross88737132017-03-21 17:41:03 -0700711 export TARGET_PRODUCT=$(get_build_var TARGET_PRODUCT)
712 export TARGET_BUILD_VARIANT=$(get_build_var TARGET_BUILD_VARIANT)
Colin Crossb105e362017-05-01 14:21:28 -0700713 if [ -n "$version" ]; then
714 export TARGET_PLATFORM_VERSION=$(get_build_var TARGET_PLATFORM_VERSION)
715 else
716 unset TARGET_PLATFORM_VERSION
717 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700718 export TARGET_BUILD_TYPE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700719
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700720 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || echo
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800721
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700722 set_stuff_for_environment
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700723 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800724 destroy_build_var_cache
Kousik Kumar41dacd12021-05-11 18:38:38 -0400725
726 if [[ -n "${CHECK_MU_CONFIG:-}" ]]; then
727 check_mu_config
728 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700729}
730
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700731unset COMMON_LUNCH_CHOICES_CACHE
Jeff Davidson513d7a42010-08-02 10:00:44 -0700732# Tab completion for lunch.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000733function _lunch()
734{
Jeff Davidson513d7a42010-08-02 10:00:44 -0700735 local cur prev opts
736 COMPREPLY=()
737 cur="${COMP_WORDS[COMP_CWORD]}"
738 prev="${COMP_WORDS[COMP_CWORD-1]}"
739
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700740 if [ -z "$COMMON_LUNCH_CHOICES_CACHE" ]; then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800741 COMMON_LUNCH_CHOICES_CACHE=$(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES)
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700742 fi
743
744 COMPREPLY=( $(compgen -W "${COMMON_LUNCH_CHOICES_CACHE}" -- ${cur}) )
Jeff Davidson513d7a42010-08-02 10:00:44 -0700745 return 0
746}
Jeff Davidson513d7a42010-08-02 10:00:44 -0700747
Joe Onoratoda12daf2010-06-09 18:18:31 -0700748# Configures the build to build unbundled apps.
Doug Zongker0d8179e2014-04-16 11:34:34 -0700749# Run tapas with one or more app names (from LOCAL_PACKAGE_NAME)
Matt Alexanderd9c56562020-05-21 10:49:17 +0000750function tapas()
751{
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700752 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Elliott Hughesf71c05a2020-03-06 16:46:59 -0800753 local arch="$(echo $* | xargs -n 1 echo | \grep -E '^(arm|x86|arm64|x86_64)$' | xargs)"
Doug Zongker0d8179e2014-04-16 11:34:34 -0700754 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700755 local density="$(echo $* | xargs -n 1 echo | \grep -E '^(ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi)$' | xargs)"
Colin Cross7f49a672022-01-27 18:15:53 -0800756 local keys="$(echo $* | xargs -n 1 echo | \grep -E '^(devkeys)$' | xargs)"
757 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|arm|x86|arm64|x86_64|ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi|devkeys)$' | xargs)"
758
Joe Onoratoda12daf2010-06-09 18:18:31 -0700759
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700760 if [ "$showHelp" != "" ]; then
761 $(gettop)/build/make/tapasHelp.sh
762 return
763 fi
764
Ying Wang67f02922012-08-22 10:25:20 -0700765 if [ $(echo $arch | wc -w) -gt 1 ]; then
766 echo "tapas: Error: Multiple build archs supplied: $arch"
767 return
768 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700769 if [ $(echo $variant | wc -w) -gt 1 ]; then
770 echo "tapas: Error: Multiple build variants supplied: $variant"
771 return
772 fi
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700773 if [ $(echo $density | wc -w) -gt 1 ]; then
774 echo "tapas: Error: Multiple densities supplied: $density"
775 return
776 fi
Colin Cross7f49a672022-01-27 18:15:53 -0800777 if [ $(echo $keys | wc -w) -gt 1 ]; then
778 echo "tapas: Error: Multiple keys supplied: $keys"
779 return
780 fi
Ying Wang67f02922012-08-22 10:25:20 -0700781
Ying Wang0a76df52015-06-08 11:57:26 -0700782 local product=aosp_arm
Ying Wang67f02922012-08-22 10:25:20 -0700783 case $arch in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000784 x86) product=aosp_x86;;
785 arm64) product=aosp_arm64;;
786 x86_64) product=aosp_x86_64;;
Ying Wang67f02922012-08-22 10:25:20 -0700787 esac
Colin Cross7f49a672022-01-27 18:15:53 -0800788 if [ -n "$keys" ]; then
789 product=${product/aosp_/aosp_${keys}_}
790 fi;
791
Joe Onoratoda12daf2010-06-09 18:18:31 -0700792 if [ -z "$variant" ]; then
793 variant=eng
794 fi
Ying Wangc048c9b2010-06-24 15:08:33 -0700795 if [ -z "$apps" ]; then
796 apps=all
797 fi
Justin Morey29d225c2014-11-04 13:35:51 -0600798 if [ -z "$density" ]; then
799 density=alldpi
800 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700801
Ying Wang67f02922012-08-22 10:25:20 -0700802 export TARGET_PRODUCT=$product
Joe Onoratoda12daf2010-06-09 18:18:31 -0700803 export TARGET_BUILD_VARIANT=$variant
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700804 export TARGET_BUILD_DENSITY=$density
Joe Onoratoda12daf2010-06-09 18:18:31 -0700805 export TARGET_BUILD_TYPE=release
806 export TARGET_BUILD_APPS=$apps
807
Ying Wang08800fd2016-03-03 20:57:21 -0800808 build_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700809 set_stuff_for_environment
810 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800811 destroy_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700812}
813
Martin Stjernholmf692c752021-04-12 00:01:10 +0100814# Configures the build to build unbundled Android modules (APEXes).
815# Run banchan with one or more module names (from apex{} modules).
816function banchan()
817{
818 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100819 local product="$(echo $* | xargs -n 1 echo | \grep -E '^(.*_)?(arm|x86|arm64|x86_64)$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100820 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100821 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|(.*_)?(arm|x86|arm64|x86_64))$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100822
823 if [ "$showHelp" != "" ]; then
824 $(gettop)/build/make/banchanHelp.sh
825 return
826 fi
827
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100828 if [ -z "$product" ]; then
829 product=arm
830 elif [ $(echo $product | wc -w) -gt 1 ]; then
831 echo "banchan: Error: Multiple build archs or products supplied: $products"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100832 return
833 fi
834 if [ $(echo $variant | wc -w) -gt 1 ]; then
835 echo "banchan: Error: Multiple build variants supplied: $variant"
836 return
837 fi
838 if [ -z "$apps" ]; then
839 echo "banchan: Error: No modules supplied"
840 return
841 fi
842
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100843 case $product in
844 arm) product=module_arm;;
Martin Stjernholmf692c752021-04-12 00:01:10 +0100845 x86) product=module_x86;;
846 arm64) product=module_arm64;;
847 x86_64) product=module_x86_64;;
848 esac
849 if [ -z "$variant" ]; then
850 variant=eng
851 fi
852
853 export TARGET_PRODUCT=$product
854 export TARGET_BUILD_VARIANT=$variant
855 export TARGET_BUILD_DENSITY=alldpi
856 export TARGET_BUILD_TYPE=release
857
858 # This setup currently uses TARGET_BUILD_APPS just like tapas, but the use
859 # case is different and it may diverge in the future.
860 export TARGET_BUILD_APPS=$apps
861
862 build_build_var_cache
863 set_stuff_for_environment
864 printconfig
865 destroy_build_var_cache
866}
867
Matt Alexanderd9c56562020-05-21 10:49:17 +0000868function gettop
869{
Colin Cross6cdc5d22017-10-20 11:37:33 -0700870 local TOPFILE=build/make/core/envsetup.mk
Matt Alexanderd9c56562020-05-21 10:49:17 +0000871 if [ -n "$TOP" -a -f "$TOP/$TOPFILE" ] ; then
Brian Carlstroma5c4f172014-09-12 00:33:25 -0700872 # The following circumlocution ensures we remove symlinks from TOP.
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000873 (cd "$TOP"; PWD= /bin/pwd)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700874 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000875 if [ -f $TOPFILE ] ; then
Dan Bornsteind0b274d2009-11-24 15:48:50 -0800876 # The following circumlocution (repeated below as well) ensures
877 # that we record the true directory name and not one that is
878 # faked up with symlink names.
879 PWD= /bin/pwd
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700880 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800881 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -0700882 local T=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000883 while [ \( ! \( -f $TOPFILE \) \) -a \( "$PWD" != "/" \) ]; do
Ying Wang9cd17642012-12-13 10:52:07 -0800884 \cd ..
synergyb112a402013-07-05 19:47:47 -0700885 T=`PWD= /bin/pwd -P`
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700886 done
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000887 \cd "$HERE"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700888 if [ -f "$T/$TOPFILE" ]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000889 echo "$T"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700890 fi
891 fi
892 fi
893}
894
Matt Alexanderd9c56562020-05-21 10:49:17 +0000895function croot()
896{
Christopher Ferris55257d22017-03-23 11:08:58 -0700897 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700898 if [ "$T" ]; then
Marie Janssen32ec50a2016-04-21 16:53:39 -0700899 if [ "$1" ]; then
900 \cd $(gettop)/$1
901 else
902 \cd $(gettop)
903 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700904 else
905 echo "Couldn't locate the top of the tree. Try setting TOP."
906 fi
907}
908
Matt Alexanderd9c56562020-05-21 10:49:17 +0000909function _croot()
910{
Anton Hanssonece9c482019-02-04 18:15:39 +0000911 local T=$(gettop)
912 if [ "$T" ]; then
913 local cur="${COMP_WORDS[COMP_CWORD]}"
914 k=0
915 for c in $(compgen -d ${T}/${cur}); do
916 COMPREPLY[k++]=${c#${T}/}/
917 done
918 fi
919}
920
Matt Alexanderd9c56562020-05-21 10:49:17 +0000921function cproj()
922{
Colin Cross6cdc5d22017-10-20 11:37:33 -0700923 local TOPFILE=build/make/core/envsetup.mk
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700924 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -0700925 local T=
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700926 while [ \( ! \( -f $TOPFILE \) \) -a \( $PWD != "/" \) ]; do
927 T=$PWD
928 if [ -f "$T/Android.mk" ]; then
Ying Wang9cd17642012-12-13 10:52:07 -0800929 \cd $T
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700930 return
931 fi
Ying Wang9cd17642012-12-13 10:52:07 -0800932 \cd ..
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700933 done
Ying Wang9cd17642012-12-13 10:52:07 -0800934 \cd $HERE
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700935 echo "can't find Android.mk"
936}
937
Daniel Sandler47e0a882013-07-30 13:23:52 -0400938# simplified version of ps; output in the form
939# <pid> <procname>
940function qpid() {
941 local prepend=''
942 local append=''
Matt Alexanderd9c56562020-05-21 10:49:17 +0000943 if [ "$1" = "--exact" ]; then
Daniel Sandler47e0a882013-07-30 13:23:52 -0400944 prepend=' '
945 append='$'
946 shift
Matt Alexanderd9c56562020-05-21 10:49:17 +0000947 elif [ "$1" = "--help" -o "$1" = "-h" ]; then
Ying Wang08800fd2016-03-03 20:57:21 -0800948 echo "usage: qpid [[--exact] <process name|pid>"
949 return 255
950 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -0400951
952 local EXE="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +0000953 if [ "$EXE" ] ; then
Ying Wang08800fd2016-03-03 20:57:21 -0800954 qpid | \grep "$prepend$EXE$append"
955 else
956 adb shell ps \
957 | tr -d '\r' \
958 | sed -e 1d -e 's/^[^ ]* *\([0-9]*\).* \([^ ]*\)$/\1 \2/'
959 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -0400960}
961
Steven Moreland74114f12020-09-10 01:23:32 +0000962# syswrite - disable verity, reboot if needed, and remount image
963#
964# Easy way to make system.img/etc writable
965function syswrite() {
966 adb wait-for-device && adb root || return 1
967 if [[ $(adb disable-verity | grep "reboot") ]]; then
968 echo "rebooting"
969 adb reboot && adb wait-for-device && adb root || return 1
970 fi
971 adb wait-for-device && adb remount || return 1
972}
973
Iliyan Malcheve675cfb2014-11-03 17:04:47 -0800974# coredump_setup - enable core dumps globally for any process
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700975# that has the core-file-size limit set correctly
976#
Iliyan Malchevaf5de972014-11-04 20:57:37 -0800977# NOTE: You must call also coredump_enable for a specific process
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700978# if its core-file-size limit is not set already.
979# NOTE: Core dumps are written to ramdisk; they will not survive a reboot!
980
Matt Alexanderd9c56562020-05-21 10:49:17 +0000981function coredump_setup()
982{
983 echo "Getting root...";
984 adb root;
985 adb wait-for-device;
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700986
Matt Alexanderd9c56562020-05-21 10:49:17 +0000987 echo "Remounting root partition read-write...";
988 adb shell mount -w -o remount -t rootfs rootfs;
989 sleep 1;
990 adb wait-for-device;
991 adb shell mkdir -p /cores;
992 adb shell mount -t tmpfs tmpfs /cores;
993 adb shell chmod 0777 /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700994
Matt Alexanderd9c56562020-05-21 10:49:17 +0000995 echo "Granting SELinux permission to dump in /cores...";
996 adb shell restorecon -R /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700997
Matt Alexanderd9c56562020-05-21 10:49:17 +0000998 echo "Set core pattern.";
999 adb shell 'echo /cores/core.%p > /proc/sys/kernel/core_pattern';
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001000
Ying Wang08800fd2016-03-03 20:57:21 -08001001 echo "Done."
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001002}
1003
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001004# coredump_enable - enable core dumps for the specified process
Matt Alexanderd9c56562020-05-21 10:49:17 +00001005# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001006#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001007# NOTE: coredump_setup must have been called as well for a core
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001008# dump to actually be generated.
1009
Matt Alexanderd9c56562020-05-21 10:49:17 +00001010function coredump_enable()
1011{
1012 local PID=$1;
Ying Wang08800fd2016-03-03 20:57:21 -08001013 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001014 printf "Expecting a PID!\n";
1015 return;
1016 fi;
1017 echo "Setting core limit for $PID to infinite...";
Elliott Hughes910a3552016-03-07 13:53:53 -08001018 adb shell /system/bin/ulimit -p $PID -c unlimited
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001019}
1020
1021# core - send SIGV and pull the core for process
Matt Alexanderd9c56562020-05-21 10:49:17 +00001022# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001023#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001024# NOTE: coredump_setup must be called once per boot for core dumps to be
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001025# enabled globally.
1026
Matt Alexanderd9c56562020-05-21 10:49:17 +00001027function core()
1028{
1029 local PID=$1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001030
Ying Wang08800fd2016-03-03 20:57:21 -08001031 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001032 printf "Expecting a PID!\n";
1033 return;
1034 fi;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001035
Matt Alexanderd9c56562020-05-21 10:49:17 +00001036 local CORENAME=core.$PID;
1037 local COREPATH=/cores/$CORENAME;
1038 local SIG=SEGV;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001039
Matt Alexanderd9c56562020-05-21 10:49:17 +00001040 coredump_enable $1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001041
Matt Alexanderd9c56562020-05-21 10:49:17 +00001042 local done=0;
Ying Wang08800fd2016-03-03 20:57:21 -08001043 while [ $(adb shell "[ -d /proc/$PID ] && echo -n yes") ]; do
Matt Alexanderd9c56562020-05-21 10:49:17 +00001044 printf "\tSending SIG%s to %d...\n" $SIG $PID;
1045 adb shell kill -$SIG $PID;
1046 sleep 1;
1047 done;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001048
Matt Alexanderd9c56562020-05-21 10:49:17 +00001049 adb shell "while [ ! -f $COREPATH ] ; do echo waiting for $COREPATH to be generated; sleep 1; done"
1050 echo "Done: core is under $COREPATH on device.";
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001051}
1052
Christopher Tate744ee802009-11-12 15:33:08 -08001053# systemstack - dump the current stack trace of all threads in the system process
1054# to the usual ANR traces file
Matt Alexanderd9c56562020-05-21 10:49:17 +00001055function systemstack()
1056{
Jeff Sharkeyf5824372013-02-19 17:00:46 -08001057 stacks system_server
1058}
1059
Michael Wrightaeed7212014-06-19 19:58:12 -07001060# Read the ELF header from /proc/$PID/exe to determine if the process is
1061# 64-bit.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001062function is64bit()
1063{
Ben Chengfba67bf2014-02-25 10:27:07 -08001064 local PID="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +00001065 if [ "$PID" ] ; then
1066 if [[ "$(adb shell cat /proc/$PID/exe | xxd -l 1 -s 4 -p)" -eq "02" ]] ; then
Ben Chengfba67bf2014-02-25 10:27:07 -08001067 echo "64"
1068 else
1069 echo ""
1070 fi
1071 else
1072 echo ""
1073 fi
1074}
1075
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001076case `uname -s` in
1077 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001078 function sgrep()
1079 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001080 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cc|cpp|hpp|S|java|kt|xml|sh|mk|aidl|vts|proto)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001081 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001082 }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001083
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001084 ;;
1085 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001086 function sgrep()
1087 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001088 find . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.\(c\|h\|cc\|cpp\|hpp\|S\|java\|kt\|xml\|sh\|mk\|aidl\|vts\|proto\)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001089 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001090 }
1091 ;;
1092esac
1093
Matt Alexanderd9c56562020-05-21 10:49:17 +00001094function gettargetarch
1095{
Raghu Gandham8da43102012-07-25 19:57:22 -07001096 get_build_var TARGET_ARCH
1097}
1098
Matt Alexanderd9c56562020-05-21 10:49:17 +00001099function ggrep()
1100{
Mike Frysinger5e479732015-09-22 18:13:48 -04001101 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.gradle" \
1102 -exec grep --color -n "$@" {} +
Jon Boekenoogencbca56f2014-04-07 10:57:38 -07001103}
1104
Matt Alexanderd9c56562020-05-21 10:49:17 +00001105function gogrep()
1106{
Orion Hodson831472d2019-10-25 11:35:15 +01001107 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.go" \
1108 -exec grep --color -n "$@" {} +
1109}
1110
Matt Alexanderd9c56562020-05-21 10:49:17 +00001111function jgrep()
1112{
Mike Frysinger5e479732015-09-22 18:13:48 -04001113 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.java" \
1114 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001115}
1116
Alistair Delva176e5342021-02-22 13:31:26 -08001117function rsgrep()
Jeff Vander Stoep1431ab82021-02-02 19:18:26 +01001118{
1119 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rs" \
1120 -exec grep --color -n "$@" {} +
1121}
1122
Taesu Leeea0cecd2020-10-28 11:05:18 +09001123function ktgrep()
1124{
1125 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.kt" \
1126 -exec grep --color -n "$@" {} +
1127}
1128
Matt Alexanderd9c56562020-05-21 10:49:17 +00001129function cgrep()
1130{
Mike Frysinger5e479732015-09-22 18:13:48 -04001131 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f \( -name '*.c' -o -name '*.cc' -o -name '*.cpp' -o -name '*.h' -o -name '*.hpp' \) \
1132 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001133}
1134
Matt Alexanderd9c56562020-05-21 10:49:17 +00001135function resgrep()
1136{
Christopher Ferris55257d22017-03-23 11:08:58 -07001137 local dir
Mike Frysinger5e479732015-09-22 18:13:48 -04001138 for dir in `find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -name res -type d`; do
1139 find $dir -type f -name '*\.xml' -exec grep --color -n "$@" {} +
1140 done
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001141}
1142
Matt Alexanderd9c56562020-05-21 10:49:17 +00001143function mangrep()
1144{
Mike Frysinger5e479732015-09-22 18:13:48 -04001145 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'AndroidManifest.xml' \
1146 -exec grep --color -n "$@" {} +
Jeff Sharkey50b61e92013-03-08 10:20:47 -08001147}
1148
Matt Alexanderd9c56562020-05-21 10:49:17 +00001149function owngrep()
1150{
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -06001151 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'OWNERS' \
1152 -exec grep --color -n "$@" {} +
1153}
1154
Matt Alexanderd9c56562020-05-21 10:49:17 +00001155function sepgrep()
1156{
Mike Frysinger5e479732015-09-22 18:13:48 -04001157 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -name sepolicy -type d \
1158 -exec grep --color -n -r --exclude-dir=\.git "$@" {} +
Alex Klyubinba5fc8e2013-05-06 14:11:48 -07001159}
1160
Matt Alexanderd9c56562020-05-21 10:49:17 +00001161function rcgrep()
1162{
Mike Frysinger5e479732015-09-22 18:13:48 -04001163 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rc*" \
1164 -exec grep --color -n "$@" {} +
Jeff Sharkeyea0068a2015-02-26 14:13:46 -08001165}
1166
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001167case `uname -s` in
1168 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001169 function mgrep()
1170 {
Orion Hodson831472d2019-10-25 11:35:15 +01001171 find -E . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -iregex '.*/(Makefile|Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001172 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001173 }
1174
Matt Alexanderd9c56562020-05-21 10:49:17 +00001175 function treegrep()
1176 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001177 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001178 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001179 }
1180
1181 ;;
1182 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001183 function mgrep()
1184 {
Orion Hodson831472d2019-10-25 11:35:15 +01001185 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -regextype posix-egrep -iregex '(.*\/Makefile|.*\/Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regextype posix-extended -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001186 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001187 }
1188
Matt Alexanderd9c56562020-05-21 10:49:17 +00001189 function treegrep()
1190 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001191 find . -name .repo -prune -o -name .git -prune -o -regextype posix-egrep -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001192 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001193 }
1194
1195 ;;
1196esac
1197
Matt Alexanderd9c56562020-05-21 10:49:17 +00001198function getprebuilt
1199{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001200 get_abs_build_var ANDROID_PREBUILTS
1201}
1202
Matt Alexanderd9c56562020-05-21 10:49:17 +00001203function tracedmdump()
1204{
Christopher Ferris55257d22017-03-23 11:08:58 -07001205 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001206 if [ ! "$T" ]; then
1207 echo "Couldn't locate the top of the tree. Try setting TOP."
1208 return
1209 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001210 local prebuiltdir=$(getprebuilt)
Raghu Gandham8da43102012-07-25 19:57:22 -07001211 local arch=$(gettargetarch)
1212 local KERNEL=$T/prebuilts/qemu-kernel/$arch/vmlinux-qemu
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001213
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001214 local TRACE=$1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001215 if [ ! "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001216 echo "usage: tracedmdump tracename"
1217 return
1218 fi
1219
Matt Alexanderd9c56562020-05-21 10:49:17 +00001220 if [ ! -r "$KERNEL" ] ; then
Jack Veenstra60116fc2009-04-09 18:12:34 -07001221 echo "Error: cannot find kernel: '$KERNEL'"
1222 return
1223 fi
1224
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001225 local BASETRACE=$(basename $TRACE)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001226 if [ "$BASETRACE" = "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001227 TRACE=$ANDROID_PRODUCT_OUT/traces/$TRACE
1228 fi
1229
1230 echo "post-processing traces..."
1231 rm -f $TRACE/qtrace.dexlist
1232 post_trace $TRACE
1233 if [ $? -ne 0 ]; then
1234 echo "***"
1235 echo "*** Error: malformed trace. Did you remember to exit the emulator?"
1236 echo "***"
1237 return
1238 fi
1239 echo "generating dexlist output..."
1240 /bin/ls $ANDROID_PRODUCT_OUT/system/framework/*.jar $ANDROID_PRODUCT_OUT/system/app/*.apk $ANDROID_PRODUCT_OUT/data/app/*.apk 2>/dev/null | xargs dexlist > $TRACE/qtrace.dexlist
1241 echo "generating dmtrace data..."
1242 q2dm -r $ANDROID_PRODUCT_OUT/symbols $TRACE $KERNEL $TRACE/dmtrace || return
1243 echo "generating html file..."
1244 dmtracedump -h $TRACE/dmtrace >| $TRACE/dmtrace.html || return
1245 echo "done, see $TRACE/dmtrace.html for details"
1246 echo "or run:"
1247 echo " traceview $TRACE/dmtrace"
1248}
1249
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001250# communicate with a running device or emulator, set up necessary state,
1251# and run the hat command.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001252function runhat()
1253{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001254 # process standard adb options
1255 local adbTarget=""
Matt Alexanderd9c56562020-05-21 10:49:17 +00001256 if [ "$1" = "-d" -o "$1" = "-e" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001257 adbTarget=$1
1258 shift 1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001259 elif [ "$1" = "-s" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001260 adbTarget="$1 $2"
1261 shift 2
1262 fi
1263 local adbOptions=${adbTarget}
Matt Alexanderd9c56562020-05-21 10:49:17 +00001264 #echo adbOptions = ${adbOptions}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001265
1266 # runhat options
1267 local targetPid=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001268
Matt Alexanderd9c56562020-05-21 10:49:17 +00001269 if [ "$targetPid" = "" ]; then
Andy McFaddenb6289852010-07-12 08:00:19 -07001270 echo "Usage: runhat [ -d | -e | -s serial ] target-pid"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001271 return
1272 fi
1273
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001274 # confirm hat is available
1275 if [ -z $(which hat) ]; then
1276 echo "hat is not available in this configuration."
1277 return
1278 fi
1279
Andy McFaddenb6289852010-07-12 08:00:19 -07001280 # issue "am" command to cause the hprof dump
Nick Kralevich9948b1e2014-07-18 15:45:38 -07001281 local devFile=/data/local/tmp/hprof-$targetPid
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001282 echo "Poking $targetPid and waiting for data..."
Dianne Hackborn6b9549f2012-09-26 15:00:59 -07001283 echo "Storing data at $devFile"
Andy McFaddenb6289852010-07-12 08:00:19 -07001284 adb ${adbOptions} shell am dumpheap $targetPid $devFile
The Android Open Source Project88b60792009-03-03 19:28:42 -08001285 echo "Press enter when logcat shows \"hprof: heap dump completed\""
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001286 echo -n "> "
1287 read
1288
The Android Open Source Project88b60792009-03-03 19:28:42 -08001289 local localFile=/tmp/$$-hprof
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001290
The Android Open Source Project88b60792009-03-03 19:28:42 -08001291 echo "Retrieving file $devFile..."
1292 adb ${adbOptions} pull $devFile $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001293
The Android Open Source Project88b60792009-03-03 19:28:42 -08001294 adb ${adbOptions} shell rm $devFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001295
The Android Open Source Project88b60792009-03-03 19:28:42 -08001296 echo "Running hat on $localFile"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001297 echo "View the output by pointing your browser at http://localhost:7000/"
1298 echo ""
Dianne Hackborn6e4e1bb2011-11-10 15:19:51 -08001299 hat -JXmx512m $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001300}
1301
Matt Alexanderd9c56562020-05-21 10:49:17 +00001302function getbugreports()
1303{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001304 local reports=(`adb shell ls /sdcard/bugreports | tr -d '\r'`)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001305
1306 if [ ! "$reports" ]; then
1307 echo "Could not locate any bugreports."
1308 return
1309 fi
1310
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001311 local report
1312 for report in ${reports[@]}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001313 do
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001314 echo "/sdcard/bugreports/${report}"
1315 adb pull /sdcard/bugreports/${report} ${report}
1316 gunzip ${report}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001317 done
1318}
1319
Matt Alexanderd9c56562020-05-21 10:49:17 +00001320function getsdcardpath()
1321{
Victoria Lease1b296b42012-08-21 15:44:06 -07001322 adb ${adbOptions} shell echo -n \$\{EXTERNAL_STORAGE\}
1323}
1324
Matt Alexanderd9c56562020-05-21 10:49:17 +00001325function getscreenshotpath()
1326{
Victoria Lease1b296b42012-08-21 15:44:06 -07001327 echo "$(getsdcardpath)/Pictures/Screenshots"
1328}
1329
Matt Alexanderd9c56562020-05-21 10:49:17 +00001330function getlastscreenshot()
1331{
Victoria Lease1b296b42012-08-21 15:44:06 -07001332 local screenshot_path=$(getscreenshotpath)
1333 local screenshot=`adb ${adbOptions} ls ${screenshot_path} | grep Screenshot_[0-9-]*.*\.png | sort -rk 3 | cut -d " " -f 4 | head -n 1`
Matt Alexanderd9c56562020-05-21 10:49:17 +00001334 if [ "$screenshot" = "" ]; then
Victoria Lease1b296b42012-08-21 15:44:06 -07001335 echo "No screenshots found."
1336 return
1337 fi
1338 echo "${screenshot}"
1339 adb ${adbOptions} pull ${screenshot_path}/${screenshot}
1340}
1341
Matt Alexanderd9c56562020-05-21 10:49:17 +00001342function startviewserver()
1343{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001344 local port=4939
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001345 if [ $# -gt 0 ]; then
1346 port=$1
1347 fi
1348 adb shell service call window 1 i32 $port
1349}
1350
Matt Alexanderd9c56562020-05-21 10:49:17 +00001351function stopviewserver()
1352{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001353 adb shell service call window 2
1354}
1355
Matt Alexanderd9c56562020-05-21 10:49:17 +00001356function isviewserverstarted()
1357{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001358 adb shell service call window 3
1359}
1360
Matt Alexanderd9c56562020-05-21 10:49:17 +00001361function key_home()
1362{
Romain Guyb84049a2010-10-04 16:56:11 -07001363 adb shell input keyevent 3
1364}
1365
Matt Alexanderd9c56562020-05-21 10:49:17 +00001366function key_back()
1367{
Romain Guyb84049a2010-10-04 16:56:11 -07001368 adb shell input keyevent 4
1369}
1370
Matt Alexanderd9c56562020-05-21 10:49:17 +00001371function key_menu()
1372{
Romain Guyb84049a2010-10-04 16:56:11 -07001373 adb shell input keyevent 82
1374}
1375
Matt Alexanderd9c56562020-05-21 10:49:17 +00001376function smoketest()
1377{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001378 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1379 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1380 return
1381 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001382 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001383 if [ ! "$T" ]; then
1384 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1385 return
1386 fi
1387
Ying Wang9cd17642012-12-13 10:52:07 -08001388 (\cd "$T" && mmm tests/SmokeTest) &&
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001389 adb uninstall com.android.smoketest > /dev/null &&
1390 adb uninstall com.android.smoketest.tests > /dev/null &&
1391 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTestApp.apk &&
1392 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTest.apk &&
1393 adb shell am instrument -w com.android.smoketest.tests/android.test.InstrumentationTestRunner
1394}
1395
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001396# simple shortcut to the runtest command
Matt Alexanderd9c56562020-05-21 10:49:17 +00001397function runtest()
1398{
Christopher Ferris55257d22017-03-23 11:08:58 -07001399 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001400 if [ ! "$T" ]; then
1401 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1402 return
1403 fi
Brett Chabot3fb149d2009-10-21 20:05:26 -07001404 ("$T"/development/testrunner/runtest.py $@)
Brett Chabot762748c2009-03-27 10:25:11 -07001405}
1406
The Android Open Source Project88b60792009-03-03 19:28:42 -08001407function godir () {
1408 if [[ -z "$1" ]]; then
1409 echo "Usage: godir <regex>"
1410 return
1411 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001412 local T=$(gettop)
1413 local FILELIST
Matt Alexanderd9c56562020-05-21 10:49:17 +00001414 if [ ! "$OUT_DIR" = "" ]; then
Brian Carlstromf2257422015-09-30 20:28:54 -07001415 mkdir -p $OUT_DIR
1416 FILELIST=$OUT_DIR/filelist
1417 else
1418 FILELIST=$T/filelist
1419 fi
1420 if [[ ! -f $FILELIST ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001421 echo -n "Creating index..."
Brian Carlstromf2257422015-09-30 20:28:54 -07001422 (\cd $T; find . -wholename ./out -prune -o -wholename ./.repo -prune -o -type f > $FILELIST)
The Android Open Source Project88b60792009-03-03 19:28:42 -08001423 echo " Done"
1424 echo ""
1425 fi
1426 local lines
Brian Carlstromf2257422015-09-30 20:28:54 -07001427 lines=($(\grep "$1" $FILELIST | sed -e 's/\/[^/]*$//' | sort | uniq))
Matt Alexanderd9c56562020-05-21 10:49:17 +00001428 if [[ ${#lines[@]} = 0 ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001429 echo "Not found"
1430 return
1431 fi
1432 local pathname
1433 local choice
1434 if [[ ${#lines[@]} > 1 ]]; then
1435 while [[ -z "$pathname" ]]; do
1436 local index=1
1437 local line
1438 for line in ${lines[@]}; do
1439 printf "%6s %s\n" "[$index]" $line
Doug Zongker29034982011-04-22 08:16:56 -07001440 index=$(($index + 1))
The Android Open Source Project88b60792009-03-03 19:28:42 -08001441 done
1442 echo
1443 echo -n "Select one: "
1444 unset choice
1445 read choice
1446 if [[ $choice -gt ${#lines[@]} || $choice -lt 1 ]]; then
1447 echo "Invalid choice"
1448 continue
1449 fi
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001450 pathname=${lines[@]:$(($choice-1)):1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001451 done
1452 else
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001453 pathname=${lines[@]:0:1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001454 fi
Ying Wang9cd17642012-12-13 10:52:07 -08001455 \cd $T/$pathname
The Android Open Source Project88b60792009-03-03 19:28:42 -08001456}
1457
Steven Moreland62054a42018-12-06 10:11:40 -08001458# Update module-info.json in out.
1459function refreshmod() {
1460 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1461 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1462 return 1
1463 fi
1464
1465 echo "Refreshing modules (building module-info.json). Log at $ANDROID_PRODUCT_OUT/module-info.json.build.log." >&2
1466
1467 # for the output of the next command
1468 mkdir -p $ANDROID_PRODUCT_OUT || return 1
1469
1470 # Note, can't use absolute path because of the way make works.
Alessandro Astonec8771be2020-05-10 11:27:57 +02001471 m $(get_build_var PRODUCT_OUT)/module-info.json \
Steven Moreland62054a42018-12-06 10:11:40 -08001472 > $ANDROID_PRODUCT_OUT/module-info.json.build.log 2>&1
1473}
1474
Cole Faust3e192382021-10-25 13:29:15 -07001475# Verifies that module-info.txt exists, returning nonzero if it doesn't.
Cole Faust24c36db2021-01-23 02:39:37 +00001476function verifymodinfo() {
Steven Moreland62054a42018-12-06 10:11:40 -08001477 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001478 if [ "$QUIET_VERIFYMODINFO" != "true" ] ; then
1479 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1480 fi
Steven Moreland62054a42018-12-06 10:11:40 -08001481 return 1
1482 fi
1483
1484 if [ ! -f "$ANDROID_PRODUCT_OUT/module-info.json" ]; then
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001485 if [ "$QUIET_VERIFYMODINFO" != "true" ] ; then
Cole Faust3e192382021-10-25 13:29:15 -07001486 echo "Could not find module-info.json. Please run 'refreshmod' first." >&2
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001487 fi
1488 return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001489 fi
Cole Faust24c36db2021-01-23 02:39:37 +00001490}
1491
1492# List all modules for the current device, as cached in module-info.json. If any build change is
1493# made and it should be reflected in the output, you should run 'refreshmod' first.
1494function allmod() {
1495 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001496
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001497 python3 -c "import json; print('\n'.join(sorted(json.load(open('$ANDROID_PRODUCT_OUT/module-info.json')).keys())))"
Steven Moreland62054a42018-12-06 10:11:40 -08001498}
1499
Joe Onorato2c1aa472021-02-25 16:42:39 -08001500# Get the path of a specific module in the android tree, as cached in module-info.json.
1501# If any build change is made, and it should be reflected in the output, you should run
1502# 'refreshmod' first. Note: This is the inverse of dirmods.
Rett Berg78d1c932019-01-24 14:34:23 -08001503function pathmod() {
Steven Moreland62054a42018-12-06 10:11:40 -08001504 if [[ $# -ne 1 ]]; then
Rett Berg78d1c932019-01-24 14:34:23 -08001505 echo "usage: pathmod <module>" >&2
Steven Moreland62054a42018-12-06 10:11:40 -08001506 return 1
1507 fi
1508
Cole Faust24c36db2021-01-23 02:39:37 +00001509 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001510
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001511 local relpath=$(python3 -c "import json, os
Steven Moreland62054a42018-12-06 10:11:40 -08001512module = '$1'
1513module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1514if module not in module_info:
1515 exit(1)
LuK1337b6a78192020-01-12 03:12:17 +01001516print(module_info[module]['path'][0])" 2>/dev/null)
Steven Moreland62054a42018-12-06 10:11:40 -08001517
1518 if [ -z "$relpath" ]; then
1519 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)." >&2
1520 return 1
1521 else
Rett Berg78d1c932019-01-24 14:34:23 -08001522 echo "$ANDROID_BUILD_TOP/$relpath"
Steven Moreland62054a42018-12-06 10:11:40 -08001523 fi
1524}
1525
Joe Onorato2c1aa472021-02-25 16:42:39 -08001526# Get the path of a specific module in the android tree, as cached in module-info.json.
1527# If any build change is made, and it should be reflected in the output, you should run
1528# 'refreshmod' first. Note: This is the inverse of pathmod.
1529function dirmods() {
1530 if [[ $# -ne 1 ]]; then
1531 echo "usage: dirmods <path>" >&2
1532 return 1
1533 fi
1534
1535 verifymodinfo || return 1
1536
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001537 python3 -c "import json, os
Joe Onorato2c1aa472021-02-25 16:42:39 -08001538dir = '$1'
1539while dir.endswith('/'):
1540 dir = dir[:-1]
1541prefix = dir + '/'
1542module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1543results = set()
1544for m in module_info.values():
1545 for path in m.get(u'path', []):
1546 if path == dir or path.startswith(prefix):
1547 name = m.get(u'module_name')
1548 if name:
1549 results.add(name)
1550for name in sorted(results):
1551 print(name)
1552"
1553}
1554
1555
Rett Berg78d1c932019-01-24 14:34:23 -08001556# Go to a specific module in the android tree, as cached in module-info.json. If any build change
1557# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1558function gomod() {
1559 if [[ $# -ne 1 ]]; then
1560 echo "usage: gomod <module>" >&2
1561 return 1
1562 fi
1563
1564 local path="$(pathmod $@)"
1565 if [ -z "$path" ]; then
1566 return 1
1567 fi
1568 cd $path
1569}
1570
Cole Faust24c36db2021-01-23 02:39:37 +00001571# Gets the list of a module's installed outputs, as cached in module-info.json.
1572# If any build change is made, and it should be reflected in the output, you should run 'refreshmod' first.
1573function outmod() {
1574 if [[ $# -ne 1 ]]; then
1575 echo "usage: outmod <module>" >&2
1576 return 1
1577 fi
1578
1579 verifymodinfo || return 1
1580
1581 local relpath
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001582 relpath=$(python3 -c "import json, os
Cole Faust24c36db2021-01-23 02:39:37 +00001583module = '$1'
1584module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1585if module not in module_info:
1586 exit(1)
1587for output in module_info[module]['installed']:
1588 print(os.path.join('$ANDROID_BUILD_TOP', output))" 2>/dev/null)
1589
1590 if [ $? -ne 0 ]; then
1591 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)" >&2
1592 return 1
1593 elif [ ! -z "$relpath" ]; then
1594 echo "$relpath"
1595 fi
1596}
1597
1598# adb install a module's apk, as cached in module-info.json. If any build change
1599# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1600# Usage: installmod [adb install arguments] <module>
1601# For example: installmod -r Dialer -> adb install -r /path/to/Dialer.apk
1602function installmod() {
1603 if [[ $# -eq 0 ]]; then
1604 echo "usage: installmod [adb install arguments] <module>" >&2
Cole Faust3e192382021-10-25 13:29:15 -07001605 echo "" >&2
1606 echo "Only flags to be passed after the \"install\" in adb install are supported," >&2
1607 echo "with the exception of -s. If -s is passed it will be placed before the \"install\"." >&2
1608 echo "-s must be the first flag passed if it exists." >&2
Cole Faust24c36db2021-01-23 02:39:37 +00001609 return 1
1610 fi
1611
1612 local _path
1613 _path=$(outmod ${@:$#:1})
1614 if [ $? -ne 0 ]; then
1615 return 1
1616 fi
1617
1618 _path=$(echo "$_path" | grep -E \\.apk$ | head -n 1)
1619 if [ -z "$_path" ]; then
1620 echo "Module '$1' does not produce a file ending with .apk (try 'refreshmod' if there have been build changes?)" >&2
1621 return 1
1622 fi
Cole Faust3e192382021-10-25 13:29:15 -07001623 local serial_device=""
1624 if [[ "$1" == "-s" ]]; then
1625 if [[ $# -le 2 ]]; then
1626 echo "-s requires an argument" >&2
1627 return 1
1628 fi
1629 serial_device="-s $2"
1630 shift 2
1631 fi
Cole Faust24c36db2021-01-23 02:39:37 +00001632 local length=$(( $# - 1 ))
Cole Faust3e192382021-10-25 13:29:15 -07001633 echo adb $serial_device install ${@:1:$length} $_path
1634 adb $serial_device install ${@:1:$length} $_path
Cole Faust24c36db2021-01-23 02:39:37 +00001635}
1636
dimitry73b84812018-12-11 18:06:00 +01001637function _complete_android_module_names() {
Steven Moreland62054a42018-12-06 10:11:40 -08001638 local word=${COMP_WORDS[COMP_CWORD]}
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001639 COMPREPLY=( $(QUIET_VERIFYMODINFO=true allmod | grep -E "^$word") )
Steven Moreland62054a42018-12-06 10:11:40 -08001640}
1641
Alex Rayf0d08eb2013-03-08 15:15:06 -08001642# Print colored exit condition
1643function pez {
Michael Wrighteb733842013-03-08 17:34:02 -08001644 "$@"
1645 local retval=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +00001646 if [ $retval -ne 0 ]
1647 then
Jacky Cao89483b82015-05-15 22:12:53 +08001648 echo $'\E'"[0;31mFAILURE\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001649 else
Jacky Cao89483b82015-05-15 22:12:53 +08001650 echo $'\E'"[0;32mSUCCESS\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001651 fi
1652 return $retval
Alex Rayf0d08eb2013-03-08 15:15:06 -08001653}
1654
Matt Alexanderd9c56562020-05-21 10:49:17 +00001655function get_make_command()
1656{
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001657 # If we're in the top of an Android tree, use soong_ui.bash instead of make
1658 if [ -f build/soong/soong_ui.bash ]; then
Dan Willemsene9842242017-07-28 13:00:13 -07001659 # Always use the real make if -C is passed in
1660 for arg in "$@"; do
1661 if [[ $arg == -C* ]]; then
1662 echo command make
1663 return
1664 fi
1665 done
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001666 echo build/soong/soong_ui.bash --make-mode
1667 else
1668 echo command make
1669 fi
Ying Wanged21d4c2014-08-24 22:14:19 -07001670}
1671
Matt Alexanderd9c56562020-05-21 10:49:17 +00001672function _wrap_build()
1673{
Sasha Smundak9f27cc02019-01-31 13:25:31 -08001674 if [[ "${ANDROID_QUIET_BUILD:-}" == true ]]; then
1675 "$@"
1676 return $?
1677 fi
Ed Heylcc6be0a2014-06-18 14:55:58 -07001678 local start_time=$(date +"%s")
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001679 "$@"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001680 local ret=$?
1681 local end_time=$(date +"%s")
1682 local tdiff=$(($end_time-$start_time))
1683 local hours=$(($tdiff / 3600 ))
1684 local mins=$((($tdiff % 3600) / 60))
1685 local secs=$(($tdiff % 60))
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001686 local ncolors=$(tput colors 2>/dev/null)
1687 if [ -n "$ncolors" ] && [ $ncolors -ge 8 ]; then
Jacky Cao89483b82015-05-15 22:12:53 +08001688 color_failed=$'\E'"[0;31m"
1689 color_success=$'\E'"[0;32m"
Kousik Kumar09af2542021-08-19 16:13:32 -04001690 color_warning=$'\E'"[0;33m"
Jacky Cao89483b82015-05-15 22:12:53 +08001691 color_reset=$'\E'"[00m"
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001692 else
1693 color_failed=""
1694 color_success=""
1695 color_reset=""
1696 fi
Kousik Kumar09af2542021-08-19 16:13:32 -04001697
1698 if [[ "x${USE_RBE}" == "x" && $mins -gt 15 && "${ANDROID_BUILD_ENVIRONMENT_CONFIG}" == "googler" ]]; then
1699 echo
1700 echo "${color_warning}Start using RBE (http://go/build-fast) to get faster builds!${color_reset}"
1701 fi
1702
Ed Heylcc6be0a2014-06-18 14:55:58 -07001703 echo
Matt Alexanderd9c56562020-05-21 10:49:17 +00001704 if [ $ret -eq 0 ] ; then
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001705 echo -n "${color_success}#### build completed successfully "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001706 else
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001707 echo -n "${color_failed}#### failed to build some targets "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001708 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +00001709 if [ $hours -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001710 printf "(%02g:%02g:%02g (hh:mm:ss))" $hours $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001711 elif [ $mins -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001712 printf "(%02g:%02g (mm:ss))" $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001713 elif [ $secs -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001714 printf "(%s seconds)" $secs
1715 fi
Jacky Cao89483b82015-05-15 22:12:53 +08001716 echo " ####${color_reset}"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001717 echo
1718 return $ret
1719}
1720
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001721function _trigger_build()
1722(
1723 local -r bc="$1"; shift
1724 if T="$(gettop)"; then
1725 _wrap_build "$T/build/soong/soong_ui.bash" --build-mode --${bc} --dir="$(pwd)" "$@"
1726 else
Jingwen Chend728ee12021-05-18 06:02:53 +00001727 >&2 echo "Couldn't locate the top of the tree. Try setting TOP."
1728 return 1
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001729 fi
1730)
1731
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001732# Convenience entry point (like m) to use Bazel in AOSP.
Jingwen Chend728ee12021-05-18 06:02:53 +00001733function b()
1734(
1735 # Generate BUILD, bzl files into the synthetic Bazel workspace (out/soong/workspace).
Lukacs T. Berki3fef6602021-09-07 08:18:35 +02001736 _trigger_build "all-modules" bp2build USE_BAZEL_ANALYSIS= || return 1
Jingwen Chend728ee12021-05-18 06:02:53 +00001737 # Then, run Bazel using the synthetic workspace as the --package_path.
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001738 if [[ -z "$@" ]]; then
1739 # If there are no args, show help.
Jingwen Chenbfa114d2021-06-17 05:42:43 +00001740 bazel help
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001741 else
1742 # Else, always run with the bp2build configuration, which sets Bazel's package path to the synthetic workspace.
Jingwen Chenbfa114d2021-06-17 05:42:43 +00001743 bazel "$@" --config=bp2build
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001744 fi
Jingwen Chend728ee12021-05-18 06:02:53 +00001745)
1746
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001747function m()
1748(
1749 _trigger_build "all-modules" "$@"
1750)
1751
1752function mm()
1753(
1754 _trigger_build "modules-in-a-dir-no-deps" "$@"
1755)
1756
1757function mmm()
1758(
1759 _trigger_build "modules-in-dirs-no-deps" "$@"
1760)
1761
1762function mma()
1763(
1764 _trigger_build "modules-in-a-dir" "$@"
1765)
1766
1767function mmma()
1768(
1769 _trigger_build "modules-in-dirs" "$@"
1770)
1771
Matt Alexanderd9c56562020-05-21 10:49:17 +00001772function make()
1773{
Dan Willemsene9842242017-07-28 13:00:13 -07001774 _wrap_build $(get_make_command "$@") "$@"
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001775}
1776
Matt Alexanderd9c56562020-05-21 10:49:17 +00001777function provision()
1778{
David Zeuthen1b126ff2015-09-30 17:10:48 -04001779 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1780 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1781 return 1
1782 fi
1783 if [ ! -e "$ANDROID_PRODUCT_OUT/provision-device" ]; then
1784 echo "There is no provisioning script for the device." >&2
1785 return 1
1786 fi
1787
1788 # Check if user really wants to do this.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001789 if [ "$1" = "--no-confirmation" ]; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001790 shift 1
1791 else
1792 echo "This action will reflash your device."
1793 echo ""
1794 echo "ALL DATA ON THE DEVICE WILL BE IRREVOCABLY ERASED."
1795 echo ""
Marie Janssen4afc2c02015-11-10 10:41:15 -08001796 echo -n "Are you sure you want to do this (yes/no)? "
1797 read
Matt Alexanderd9c56562020-05-21 10:49:17 +00001798 if [[ "${REPLY}" != "yes" ]] ; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001799 echo "Not taking any action. Exiting." >&2
1800 return 1
1801 fi
1802 fi
1803 "$ANDROID_PRODUCT_OUT/provision-device" "$@"
1804}
1805
Jim Tanga881a252018-06-19 16:34:41 +08001806# Zsh needs bashcompinit called to support bash-style completion.
Patrik Fimmldf248e62018-10-15 18:15:12 +02001807function enable_zsh_completion() {
1808 # Don't override user's options if bash-style completion is already enabled.
1809 if ! declare -f complete >/dev/null; then
1810 autoload -U compinit && compinit
1811 autoload -U bashcompinit && bashcompinit
1812 fi
Jim Tanga881a252018-06-19 16:34:41 +08001813}
1814
1815function validate_current_shell() {
1816 local current_sh="$(ps -o command -p $$)"
1817 case "$current_sh" in
Raphael Moll70a86b02011-06-20 16:03:14 -07001818 *bash*)
Jim Tanga881a252018-06-19 16:34:41 +08001819 function check_type() { type -t "$1"; }
Raphael Moll70a86b02011-06-20 16:03:14 -07001820 ;;
Jim Tanga881a252018-06-19 16:34:41 +08001821 *zsh*)
1822 function check_type() { type "$1"; }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001823 enable_zsh_completion ;;
Raphael Moll70a86b02011-06-20 16:03:14 -07001824 *)
Jim Tanga881a252018-06-19 16:34:41 +08001825 echo -e "WARNING: Only bash and zsh are supported.\nUse of other shell would lead to erroneous results."
Raphael Moll70a86b02011-06-20 16:03:14 -07001826 ;;
1827 esac
Jim Tanga881a252018-06-19 16:34:41 +08001828}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001829
1830# Execute the contents of any vendorsetup.sh files we can find.
Dan Willemsend855a722019-02-12 15:52:36 -08001831# Unless we find an allowed-vendorsetup_sh-files file, in which case we'll only
1832# load those.
1833#
1834# This allows loading only approved vendorsetup.sh files
Jim Tanga881a252018-06-19 16:34:41 +08001835function source_vendorsetup() {
Jim Tangc4dba1d2019-07-25 16:54:27 +08001836 unset VENDOR_PYTHONPATH
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001837 local T="$(gettop)"
Dan Willemsend855a722019-02-12 15:52:36 -08001838 allowed=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001839 for f in $(cd "$T" && find -L device vendor product -maxdepth 4 -name 'allowed-vendorsetup_sh-files' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001840 if [ -n "$allowed" ]; then
1841 echo "More than one 'allowed_vendorsetup_sh-files' file found, not including any vendorsetup.sh files:"
1842 echo " $allowed"
1843 echo " $f"
1844 return
1845 fi
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001846 allowed="$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001847 done
1848
1849 allowed_files=
1850 [ -n "$allowed" ] && allowed_files=$(cat "$allowed")
Jim Tanga881a252018-06-19 16:34:41 +08001851 for dir in device vendor product; do
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001852 for f in $(cd "$T" && test -d $dir && \
Jim Tanga881a252018-06-19 16:34:41 +08001853 find -L $dir -maxdepth 4 -name 'vendorsetup.sh' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001854
1855 if [[ -z "$allowed" || "$allowed_files" =~ $f ]]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001856 echo "including $f"; . "$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001857 else
1858 echo "ignoring $f, not in $allowed"
1859 fi
Jim Tanga881a252018-06-19 16:34:41 +08001860 done
1861 done
1862}
Kenny Root52aa81c2011-07-15 11:07:06 -07001863
Dan Albertbab814f2020-08-26 15:34:53 -07001864function showcommands() {
1865 local T=$(gettop)
1866 if [[ -z "$TARGET_PRODUCT" ]]; then
1867 >&2 echo "TARGET_PRODUCT not set. Run lunch."
1868 return
1869 fi
1870 case $(uname -s) in
1871 Darwin)
1872 PREBUILT_NAME=darwin-x86
1873 ;;
1874 Linux)
1875 PREBUILT_NAME=linux-x86
1876 ;;
1877 *)
1878 >&2 echo Unknown host $(uname -s)
1879 return
1880 ;;
1881 esac
1882 if [[ -z "$OUT_DIR" ]]; then
1883 if [[ -z "$OUT_DIR_COMMON_BASE" ]]; then
1884 OUT_DIR=out
1885 else
1886 OUT_DIR=${OUT_DIR_COMMON_BASE}/${PWD##*/}
1887 fi
1888 fi
1889 if [[ "$1" == "--regenerate" ]]; then
1890 shift 1
1891 NINJA_ARGS="-t commands $@" m
1892 else
1893 (cd $T && prebuilts/build-tools/$PREBUILT_NAME/bin/ninja \
1894 -f $OUT_DIR/combined-${TARGET_PRODUCT}.ninja \
1895 -t commands "$@")
1896 fi
1897}
1898
Jim Tanga881a252018-06-19 16:34:41 +08001899validate_current_shell
1900source_vendorsetup
Kenny Root52aa81c2011-07-15 11:07:06 -07001901addcompletions